#!/sbin/bash


#Metamorph files
cp -f /tmp/bin/zip /sbin/zip
cp -f /tmp/bin/zipalign /sbin/zipalign
chmod 0755 /sbin/zip
chmod 0755 /sbin/zipalign

echo "start metamorph script..."

APP_DIR=/tmp/mm
SYS_DIR=/system/app
SYS_FRAME=/system/framework



if [ -d "$APP_DIR" ]; then
	for DIR in "$APP_DIR"/*
	do
	BASE_DIR=`basename "$DIR"`
	echo " "
	echo "found $BASE_DIR"
		if [ -f "$SYS_DIR/$BASE_DIR.apk" ]; then
			cp -f /tmp/apk/$BASE_DIR.apk $SYS_DIR/$BASE_DIR.apk
			chmod 644 $SYS_DIR/$BASE_DIR.apk
			echo -n "add new files to $BASE_DIR ..."
			cd $DIR
			/sbin/zip -r $SYS_DIR/$BASE_DIR.apk * > /dev/null 2>&1
			echo " done"
			/sbin/zipalign -c 4 $SYS_DIR/$BASE_DIR.apk > /dev/null 2>&1
			ZIPCHECK=$?
			if busybox [ $ZIPCHECK -eq 1 ]; then
				echo -n "ZipAligning $BASE_DIR.apk..."  
				/sbin/zipalign -f 4 $SYS_DIR/$BASE_DIR.apk /cache/$BASE_DIR.apk > /dev/null 2>&1
				if busybox [ -e /cache/$BASE_DIR.apk ]; then
					busybox cp -f /cache/$BASE_DIR.apk $SYS_DIR/$BASE_DIR.apk  
					busybox rm /cache/$BASE_DIR.apk
					echo " done"
				else
					echo " Failed" 
				fi
			else
				echo "ZipAlign already completed on $BASE_DIR.apk "
			fi
			
		elif [ -f "$SYS_FRAME/$BASE_DIR.apk" ]; then
			echo -n "add new files to $BASE_DIR ..."
			cd $DIR
			/sbin/zip -r $SYS_FRAME/$BASE_DIR.apk * > /dev/null 2>&1
			echo " done"
			/sbin/zipalign -c 4 $SYS_FRAME/$BASE_DIR.apk > /dev/null 2>&1
			ZIPCHECK=$?
			if busybox [ $ZIPCHECK -eq 1 ]; then
				echo -n "ZipAligning $BASE_DIR.apk..."  
				/sbin/zipalign -f 4 $SYS_FRAME/$BASE_DIR.apk /cache/$BASE_DIR.apk > /dev/null 2>&1
				if busybox [ -e /cache/$BASE_DIR.apk ]; then
					busybox cp -f /cache/$BASE_DIR.apk $SYS_FRAME/$BASE_DIR.apk  
					busybox rm /cache/$BASE_DIR.apk
					echo " done"
				else
					echo " Failed" 
				fi
			else
				echo "ZipAlign already completed on $BASE_DIR.apk "
			fi
			
		fi
	done
fi
echo "... install done"
	
exit 0
